Index: drivers/filesystems/btrfs/flushthread.c
===================================================================
--- drivers/filesystems/btrfs/flushthread.c	(révision 75772)
+++ drivers/filesystems/btrfs/flushthread.c	(copie de travail)
@@ -480,16 +765,16 @@
             return STATUS_SUCCESS;
         }
     }
-    
+
     ExAcquireResourceExclusiveLite(&Vcb->chunk_lock, TRUE);
-    
+
     le = Vcb->chunks.Flink;
     while (le != &Vcb->chunks) {
         c = CONTAINING_RECORD(le, chunk, list_entry);
-        
+
         if (!c->readonly && !c->reloc) {
             ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-            
+
             if (c != origchunk && c->chunk_item->type == flags && (c->chunk_item->size - c->used) >= Vcb->superblock.node_size) {
                 if (insert_tree_extent(Vcb, t->header.level, t->root->id, c, &addr, Irp, rollback)) {
                     ExReleaseResourceLite(&c->lock);
@@ -499,74 +784,48 @@
                     return STATUS_SUCCESS;
                 }
             }
-            
+
             ExReleaseResourceLite(&c->lock);
         }
 
         le = le->Flink;
     }
-    
+
     // allocate new chunk if necessary
-    if ((c = alloc_chunk(Vcb, flags))) {
-        ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-        
-        if ((c->chunk_item->size - c->used) >= Vcb->superblock.node_size) {
-            if (insert_tree_extent(Vcb, t->header.level, t->root->id, c, &addr, Irp, rollback)) {
-                ExReleaseResourceLite(&c->lock);
-                ExReleaseResourceLite(&Vcb->chunk_lock);
-                t->new_address = addr;
-                t->has_new_address = TRUE;
-                return STATUS_SUCCESS;
-            }
+
+    Status = alloc_chunk(Vcb, flags, &c, FALSE);
+
+    if (!NT_SUCCESS(Status)) {
+        ERR("alloc_chunk returned %08x\n", Status);
+        ExReleaseResourceLite(&Vcb->chunk_lock);
+        return Status;
+    }
+
+    ExAcquireResourceExclusiveLite(&c->lock, TRUE);
+
+    if ((c->chunk_item->size - c->used) >= Vcb->superblock.node_size) {
+        if (insert_tree_extent(Vcb, t->header.level, t->root->id, c, &addr, Irp, rollback)) {
+            ExReleaseResourceLite(&c->lock);
+            ExReleaseResourceLite(&Vcb->chunk_lock);
+            t->new_address = addr;
+            t->has_new_address = TRUE;
+            return STATUS_SUCCESS;
         }
-        
-        ExReleaseResourceLite(&c->lock);
     }
-    
+
+    ExReleaseResourceLite(&c->lock);
+
     ExReleaseResourceLite(&Vcb->chunk_lock);
-    
+
     ERR("couldn't find any metadata chunks with %x bytes free\n", Vcb->superblock.node_size);
 
     return STATUS_DISK_FULL;
 }
 
-// TESTING
-// static void check_tree_num_items(tree* t) {
-//     LIST_ENTRY* le2;
-//     UINT32 ni;
-//     
-//     le2 = t->itemlist.Flink;
-//     ni = 0;
-//     while (le2 != &t->itemlist) {
-//         tree_data* td = CONTAINING_RECORD(le2, tree_data, list_entry);
-//         if (!td->ignore)
-//             ni++;
-//         le2 = le2->Flink;
-//     }
-//     
-//     if (t->header.num_items != ni) {
-//         ERR("tree %p not okay: num_items was %x, expecting %x\n", t, ni, t->header.num_items);
-//         int3;
-//     } else {
-//         ERR("tree %p okay\n", t);
-//     }
-// }
-// 
-// static void check_trees_num_items(LIST_ENTRY* tc) {
-//     LIST_ENTRY* le = tc->Flink;
-//     while (le != tc) {
-//         tree_cache* tc2 = CONTAINING_RECORD(le, tree_cache, list_entry);
-//         
-//         check_tree_num_items(tc2->tree);
-//         
-//         le = le->Flink;
-//     }    
-// }
-
 static NTSTATUS reduce_tree_extent(device_extension* Vcb, UINT64 address, tree* t, UINT64 parent_root, UINT8 level, PIRP Irp, LIST_ENTRY* rollback) {
     NTSTATUS Status;
     UINT64 rc, root;
-    
+
     TRACE("(%p, %llx, %p)\n", Vcb, address, t);
 
     rc = get_extent_refcount(Vcb, address, Vcb->superblock.node_size, Irp);
@@ -574,13 +833,13 @@
         ERR("error - refcount for extent %llx was 0\n", address);
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     if (!t || t->parent)
         root = parent_root;
     else
         root = t->header.tree_id;
-    
-    Status = decrease_extent_refcount_tree(Vcb, address, Vcb->superblock.node_size, root, level, Irp, rollback);
+
+    Status = decrease_extent_refcount_tree(Vcb, address, Vcb->superblock.node_size, root, level, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("decrease_extent_refcount_tree returned %08x\n", Status);
         return Status;
@@ -588,19 +847,29 @@
 
     if (rc == 1) {
         chunk* c = get_chunk_from_address(Vcb, address);
-        
+
         if (c) {
             ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-            
-            decrease_chunk_usage(c, Vcb->superblock.node_size);
-            
-            space_list_add(Vcb, c, TRUE, address, Vcb->superblock.node_size, rollback);
-            
+
+            if (!c->cache_loaded) {
+                Status = load_cache_chunk(Vcb, c, NULL);
+
+                if (!NT_SUCCESS(Status)) {
+                    ERR("load_cache_chunk returned %08x\n", Status);
+                    ExReleaseResourceLite(&c->lock);
+                    return Status;
+                }
+            }
+
+            c->used -= Vcb->superblock.node_size;
+
+            space_list_add(c, address, Vcb->superblock.node_size, rollback);
+
             ExReleaseResourceLite(&c->lock);
         } else
             ERR("could not find chunk for address %llx\n", address);
     }
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -607,37 +876,37 @@
 static NTSTATUS add_changed_extent_ref_edr(changed_extent* ce, EXTENT_DATA_REF* edr, BOOL old) {
     LIST_ENTRY *le2, *list;
     changed_extent_ref* cer;
-    
+
     list = old ? &ce->old_refs : &ce->refs;
-    
+
     le2 = list->Flink;
     while (le2 != list) {
         cer = CONTAINING_RECORD(le2, changed_extent_ref, list_entry);
-        
+
         if (cer->type == TYPE_EXTENT_DATA_REF && cer->edr.root == edr->root && cer->edr.objid == edr->objid && cer->edr.offset == edr->offset) {
             cer->edr.count += edr->count;
             goto end;
         }
-        
+
         le2 = le2->Flink;
     }
-    
+
     cer = ExAllocatePoolWithTag(PagedPool, sizeof(changed_extent_ref), ALLOC_TAG);
     if (!cer) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     cer->type = TYPE_EXTENT_DATA_REF;
     RtlCopyMemory(&cer->edr, edr, sizeof(EXTENT_DATA_REF));
     InsertTailList(list, &cer->list_entry);
-    
+
 end:
     if (old)
         ce->old_count += edr->count;
     else
         ce->count += edr->count;
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -644,31 +913,31 @@
 static NTSTATUS add_changed_extent_ref_sdr(changed_extent* ce, SHARED_DATA_REF* sdr, BOOL old) {
     LIST_ENTRY *le2, *list;
     changed_extent_ref* cer;
-    
+
     list = old ? &ce->old_refs : &ce->refs;
-    
+
     le2 = list->Flink;
     while (le2 != list) {
         cer = CONTAINING_RECORD(le2, changed_extent_ref, list_entry);
-        
+
         if (cer->type == TYPE_SHARED_DATA_REF && cer->sdr.offset == sdr->offset) {
             cer->sdr.count += sdr->count;
             goto end;
         }
-        
+
         le2 = le2->Flink;
     }
-    
+
     cer = ExAllocatePoolWithTag(PagedPool, sizeof(changed_extent_ref), ALLOC_TAG);
     if (!cer) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     cer->type = TYPE_SHARED_DATA_REF;
     RtlCopyMemory(&cer->sdr, sdr, sizeof(SHARED_DATA_REF));
     InsertTailList(list, &cer->list_entry);
-    
+
 end:
     if (old)
         ce->old_count += sdr->count;
@@ -682,7 +951,7 @@
     KEY searchkey;
     traverse_ptr tp;
     NTSTATUS Status;
-    
+
     if (!t->updated_extents && t->has_address) {
         Status = update_tree_extents(Vcb, t, Irp, rollback);
         if (!NT_SUCCESS(Status)) {
@@ -690,17 +959,17 @@
             return FALSE;
         }
     }
-    
+
     searchkey.obj_id = t->header.address;
     searchkey.obj_type = Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA ? TYPE_METADATA_ITEM : TYPE_EXTENT_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return FALSE;
     }
-    
+
     if (tp.item->key.obj_id == t->header.address && (tp.item->key.obj_type == TYPE_METADATA_ITEM || tp.item->key.obj_type == TYPE_EXTENT_ITEM))
         return FALSE;
     else
@@ -711,41 +980,41 @@
     NTSTATUS Status;
     UINT64 rc = get_extent_refcount(Vcb, t->header.address, Vcb->superblock.node_size, Irp);
     UINT64 flags = get_extent_flags(Vcb, t->header.address, Irp);
-    
+
     if (rc == 0) {
         ERR("refcount for extent %llx was 0\n", t->header.address);
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     if (flags & EXTENT_ITEM_SHARED_BACKREFS || t->header.flags & HEADER_FLAG_SHARED_BACKREF || !(t->header.flags & HEADER_FLAG_MIXED_BACKREF)) {
         TREE_BLOCK_REF tbr;
         BOOL unique = rc > 1 ? FALSE : (t->parent ? shared_tree_is_unique(Vcb, t->parent, Irp, rollback) : FALSE);
-        
+
         if (t->header.level == 0) {
             LIST_ENTRY* le;
-            
+
             le = t->itemlist.Flink;
             while (le != &t->itemlist) {
                 tree_data* td = CONTAINING_RECORD(le, tree_data, list_entry);
-                
+
                 if (!td->inserted && td->key.obj_type == TYPE_EXTENT_DATA && td->size >= sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2)) {
                     EXTENT_DATA* ed = (EXTENT_DATA*)td->data;
-                    
+
                     if (ed->type == EXTENT_TYPE_REGULAR || ed->type == EXTENT_TYPE_PREALLOC) {
                         EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ed->data;
-                            
+
                         if (ed2->size > 0) {
                             EXTENT_DATA_REF edr;
                             changed_extent* ce = NULL;
                             chunk* c = get_chunk_from_address(Vcb, ed2->address);
-                            
+
                             if (c) {
                                 LIST_ENTRY* le2;
-                                
+
                                 le2 = c->changed_extents.Flink;
                                 while (le2 != &c->changed_extents) {
                                     changed_extent* ce2 = CONTAINING_RECORD(le2, changed_extent, list_entry);
-                                    
+
                                     if (ce2->address == ed2->address) {
                                         ce = ce2;
                                         break;
@@ -754,12 +1023,12 @@
                                     le2 = le2->Flink;
                                 }
                             }
-                                    
+
                             edr.root = t->root->id;
                             edr.objid = td->key.obj_id;
                             edr.offset = td->key.offset - ed2->offset;
                             edr.count = 1;
-                            
+
                             if (ce) {
                                 Status = add_changed_extent_ref_edr(ce, &edr, TRUE);
                                 if (!NT_SUCCESS(Status)) {
@@ -766,7 +1035,7 @@
                                     ERR("add_changed_extent_ref_edr returned %08x\n", Status);
                                     return Status;
                                 }
-                                
+
                                 Status = add_changed_extent_ref_edr(ce, &edr, FALSE);
                                 if (!NT_SUCCESS(Status)) {
                                     ERR("add_changed_extent_ref_edr returned %08x\n", Status);
@@ -773,52 +1042,52 @@
                                     return Status;
                                 }
                             }
-                            
-                            Status = increase_extent_refcount(Vcb, ed2->address, ed2->size, TYPE_EXTENT_DATA_REF, &edr, NULL, 0, Irp, rollback);
+
+                            Status = increase_extent_refcount(Vcb, ed2->address, ed2->size, TYPE_EXTENT_DATA_REF, &edr, NULL, 0, Irp);
                             if (!NT_SUCCESS(Status)) {
                                 ERR("increase_extent_refcount returned %08x\n", Status);
                                 return Status;
                             }
-                            
+
                             if ((flags & EXTENT_ITEM_SHARED_BACKREFS && unique) || !(t->header.flags & HEADER_FLAG_MIXED_BACKREF)) {
                                 UINT64 sdrrc = find_extent_shared_data_refcount(Vcb, ed2->address, t->header.address, Irp);
 
                                 if (sdrrc > 0) {
                                     SHARED_DATA_REF sdr;
-                                    
+
                                     sdr.offset = t->header.address;
                                     sdr.count = 1;
-                                    
+
                                     Status = decrease_extent_refcount(Vcb, ed2->address, ed2->size, TYPE_SHARED_DATA_REF, &sdr, NULL, 0,
-                                                                      t->header.address, ce->superseded, Irp, rollback);
+                                                                      t->header.address, ce ? ce->superseded : FALSE, Irp);
                                     if (!NT_SUCCESS(Status)) {
                                         ERR("decrease_extent_refcount returned %08x\n", Status);
                                         return Status;
                                     }
-                                    
+
                                     if (ce) {
                                         LIST_ENTRY* le2;
-                                        
+
                                         le2 = ce->refs.Flink;
                                         while (le2 != &ce->refs) {
                                             changed_extent_ref* cer = CONTAINING_RECORD(le2, changed_extent_ref, list_entry);
-                                            
+
                                             if (cer->type == TYPE_SHARED_DATA_REF && cer->sdr.offset == sdr.offset) {
                                                 ce->count--;
                                                 cer->sdr.count--;
                                                 break;
                                             }
-                                            
+
                                             le2 = le2->Flink;
                                         }
-                                        
+
                                         le2 = ce->old_refs.Flink;
                                         while (le2 != &ce->old_refs) {
                                             changed_extent_ref* cer = CONTAINING_RECORD(le2, changed_extent_ref, list_entry);
-                                            
+
                                             if (cer->type == TYPE_SHARED_DATA_REF && cer->sdr.offset == sdr.offset) {
                                                 ce->old_count--;
-                                                
+
                                                 if (cer->sdr.count > 1)
                                                     cer->sdr.count--;
                                                 else {
@@ -825,52 +1094,50 @@
                                                     RemoveEntryList(&cer->list_entry);
                                                     ExFreePool(cer);
                                                 }
-                                                
+
                                                 break;
                                             }
-                                            
+
                                             le2 = le2->Flink;
                                         }
                                     }
                                 }
                             }
-                            
+
                             // FIXME - clear shared flag if unique?
                         }
                     }
                 }
-                
+
                 le = le->Flink;
             }
         } else {
             LIST_ENTRY* le;
-            
+
             le = t->itemlist.Flink;
             while (le != &t->itemlist) {
                 tree_data* td = CONTAINING_RECORD(le, tree_data, list_entry);
-                
+
                 if (!td->inserted) {
-                    TREE_BLOCK_REF tbr;
-                    
                     tbr.offset = t->root->id;
-                    
+
                     Status = increase_extent_refcount(Vcb, td->treeholder.address, Vcb->superblock.node_size, TYPE_TREE_BLOCK_REF,
-                                                      &tbr, &td->key, t->header.level - 1, Irp, rollback);
+                                                      &tbr, &td->key, t->header.level - 1, Irp);
                     if (!NT_SUCCESS(Status)) {
                         ERR("increase_extent_refcount returned %08x\n", Status);
                         return Status;
                     }
-                    
+
                     if (unique || !(t->header.flags & HEADER_FLAG_MIXED_BACKREF)) {
                         UINT64 sbrrc = find_extent_shared_tree_refcount(Vcb, td->treeholder.address, t->header.address, Irp);
 
                         if (sbrrc > 0) {
                             SHARED_BLOCK_REF sbr;
-                
+
                             sbr.offset = t->header.address;
-                            
+
                             Status = decrease_extent_refcount(Vcb, td->treeholder.address, Vcb->superblock.node_size, TYPE_SHARED_BLOCK_REF, &sbr, NULL, 0,
-                                                              t->header.address, FALSE, Irp, rollback);
+                                                              t->header.address, FALSE, Irp);
                             if (!NT_SUCCESS(Status)) {
                                 ERR("decrease_extent_refcount returned %08x\n", Status);
                                 return Status;
@@ -877,24 +1144,24 @@
                             }
                         }
                     }
-                            
+
                     // FIXME - clear shared flag if unique?
                 }
-                
+
                 le = le->Flink;
             }
         }
-        
+
         if (unique) {
             UINT64 sbrrc = find_extent_shared_tree_refcount(Vcb, t->header.address, t->parent->header.address, Irp);
-            
+
             if (sbrrc == 1) {
                 SHARED_BLOCK_REF sbr;
-                
+
                 sbr.offset = t->parent->header.address;
-                
+
                 Status = decrease_extent_refcount(Vcb, t->header.address, Vcb->superblock.node_size, TYPE_SHARED_BLOCK_REF, &sbr, NULL, 0,
-                                                  t->parent->header.address, FALSE, Irp, rollback);
+                                                  t->parent->header.address, FALSE, Irp);
                 if (!NT_SUCCESS(Status)) {
                     ERR("decrease_extent_refcount returned %08x\n", Status);
                     return Status;
@@ -901,93 +1168,95 @@
                 }
             }
         }
-        
+
         if (t->parent)
             tbr.offset = t->parent->header.tree_id;
         else
             tbr.offset = t->header.tree_id;
-        
+
         Status = increase_extent_refcount(Vcb, t->header.address, Vcb->superblock.node_size, TYPE_TREE_BLOCK_REF, &tbr,
-                                          t->parent ? &t->paritem->key : NULL, t->header.level, Irp, rollback);
+                                          t->parent ? &t->paritem->key : NULL, t->header.level, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("increase_extent_refcount returned %08x\n", Status);
             return Status;
         }
-        
+
         // FIXME - clear shared flag if unique?
-        
+
         t->header.flags &= ~HEADER_FLAG_SHARED_BACKREF;
     }
-    
-    Status = reduce_tree_extent(Vcb, t->header.address, t, t->parent ? t->parent->header.tree_id : t->header.tree_id, t->header.level, Irp, rollback);
-    
-    if (!NT_SUCCESS(Status)) {
-        ERR("reduce_tree_extent returned %08x\n", Status);
-        return Status;
+
+    if (rc > 1 || t->header.tree_id == t->root->id) {
+        Status = reduce_tree_extent(Vcb, t->header.address, t, t->parent ? t->parent->header.tree_id : t->header.tree_id, t->header.level, Irp, rollback);
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("reduce_tree_extent returned %08x\n", Status);
+            return Status;
+        }
     }
-    
+
     t->has_address = FALSE;
-    
-    if (rc > 1 && !(flags & EXTENT_ITEM_SHARED_BACKREFS)) {
+
+    if ((rc > 1 || t->header.tree_id != t->root->id) && !(flags & EXTENT_ITEM_SHARED_BACKREFS)) {
         if (t->header.tree_id == t->root->id) {
             flags |= EXTENT_ITEM_SHARED_BACKREFS;
             update_extent_flags(Vcb, t->header.address, flags, Irp);
         }
-        
+
         if (t->header.level > 0) {
             LIST_ENTRY* le;
-            
+
             le = t->itemlist.Flink;
             while (le != &t->itemlist) {
                 tree_data* td = CONTAINING_RECORD(le, tree_data, list_entry);
-                
+
                 if (!td->inserted) {
                     if (t->header.tree_id == t->root->id) {
                         SHARED_BLOCK_REF sbr;
-                        
+
                         sbr.offset = t->header.address;
-                        
-                        Status = increase_extent_refcount(Vcb, td->treeholder.address, Vcb->superblock.node_size, TYPE_SHARED_BLOCK_REF, &sbr, &td->key, t->header.level - 1, Irp, rollback);
+
+                        Status = increase_extent_refcount(Vcb, td->treeholder.address, Vcb->superblock.node_size, TYPE_SHARED_BLOCK_REF, &sbr, &td->key, t->header.level - 1, Irp);
                     } else {
                         TREE_BLOCK_REF tbr;
-                        
+
                         tbr.offset = t->root->id;
-                        
-                        Status = increase_extent_refcount(Vcb, td->treeholder.address, Vcb->superblock.node_size, TYPE_TREE_BLOCK_REF, &tbr, &td->key, t->header.level - 1, Irp, rollback);
+
+                        Status = increase_extent_refcount(Vcb, td->treeholder.address, Vcb->superblock.node_size, TYPE_TREE_BLOCK_REF, &tbr, &td->key, t->header.level - 1, Irp);
                     }
-                    
+
                     if (!NT_SUCCESS(Status)) {
                         ERR("increase_extent_refcount returned %08x\n", Status);
                         return Status;
                     }
                 }
-                
+
                 le = le->Flink;
             }
         } else {
             LIST_ENTRY* le;
-            
+
             le = t->itemlist.Flink;
             while (le != &t->itemlist) {
                 tree_data* td = CONTAINING_RECORD(le, tree_data, list_entry);
-                
+
                 if (!td->inserted && td->key.obj_type == TYPE_EXTENT_DATA && td->size >= sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2)) {
                     EXTENT_DATA* ed = (EXTENT_DATA*)td->data;
-                    
+
                     if (ed->type == EXTENT_TYPE_REGULAR || ed->type == EXTENT_TYPE_PREALLOC) {
                         EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ed->data;
-                        
+
                         if (ed2->size > 0) {
                             changed_extent* ce = NULL;
                             chunk* c = get_chunk_from_address(Vcb, ed2->address);
-                            
+
                             if (c) {
                                 LIST_ENTRY* le2;
-                                
+
                                 le2 = c->changed_extents.Flink;
                                 while (le2 != &c->changed_extents) {
                                     changed_extent* ce2 = CONTAINING_RECORD(le2, changed_extent, list_entry);
-                                    
+
                                     if (ce2->address == ed2->address) {
                                         ce = ce2;
                                         break;
@@ -996,13 +1265,13 @@
                                     le2 = le2->Flink;
                                 }
                             }
-                            
+
                             if (t->header.tree_id == t->root->id) {
                                 SHARED_DATA_REF sdr;
-                                
+
                                 sdr.offset = t->header.address;
                                 sdr.count = 1;
-                                
+
                                 if (ce) {
                                     Status = add_changed_extent_ref_sdr(ce, &sdr, TRUE);
                                     if (!NT_SUCCESS(Status)) {
@@ -1009,7 +1278,7 @@
                                         ERR("add_changed_extent_ref_edr returned %08x\n", Status);
                                         return Status;
                                     }
-                                    
+
                                     Status = add_changed_extent_ref_sdr(ce, &sdr, FALSE);
                                     if (!NT_SUCCESS(Status)) {
                                         ERR("add_changed_extent_ref_edr returned %08x\n", Status);
@@ -1016,16 +1285,16 @@
                                         return Status;
                                     }
                                 }
-                                
-                                Status = increase_extent_refcount(Vcb, ed2->address, ed2->size, TYPE_SHARED_DATA_REF, &sdr, NULL, 0, Irp, rollback);
+
+                                Status = increase_extent_refcount(Vcb, ed2->address, ed2->size, TYPE_SHARED_DATA_REF, &sdr, NULL, 0, Irp);
                             } else {
                                 EXTENT_DATA_REF edr;
-                                
+
                                 edr.root = t->root->id;
                                 edr.objid = td->key.obj_id;
                                 edr.offset = td->key.offset - ed2->offset;
                                 edr.count = 1;
-                                
+
                                 if (ce) {
                                     Status = add_changed_extent_ref_edr(ce, &edr, TRUE);
                                     if (!NT_SUCCESS(Status)) {
@@ -1032,7 +1301,7 @@
                                         ERR("add_changed_extent_ref_edr returned %08x\n", Status);
                                         return Status;
                                     }
-                                    
+
                                     Status = add_changed_extent_ref_edr(ce, &edr, FALSE);
                                     if (!NT_SUCCESS(Status)) {
                                         ERR("add_changed_extent_ref_edr returned %08x\n", Status);
@@ -1039,10 +1308,10 @@
                                         return Status;
                                     }
                                 }
-                                
-                                Status = increase_extent_refcount(Vcb, ed2->address, ed2->size, TYPE_EXTENT_DATA_REF, &edr, NULL, 0, Irp, rollback);
+
+                                Status = increase_extent_refcount(Vcb, ed2->address, ed2->size, TYPE_EXTENT_DATA_REF, &edr, NULL, 0, Irp);
                             }
-                            
+
                             if (!NT_SUCCESS(Status)) {
                                 ERR("increase_extent_refcount returned %08x\n", Status);
                                 return Status;
@@ -1050,15 +1319,15 @@
                         }
                     }
                 }
-                
+
                 le = le->Flink;
             }
         }
     }
-    
+
     t->updated_extents = TRUE;
     t->header.tree_id = t->root->id;
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -1067,51 +1336,73 @@
     NTSTATUS Status;
     BOOL changed = FALSE;
     UINT8 max_level = 0, level;
-    
+
     TRACE("(%p)\n", Vcb);
-    
+
     le = Vcb->trees.Flink;
     while (le != &Vcb->trees) {
         tree* t = CONTAINING_RECORD(le, tree, list_entry);
-        
+
         if (t->write && !t->has_new_address) {
             chunk* c;
-            
+
+            if (t->has_address) {
+                c = get_chunk_from_address(Vcb, t->header.address);
+
+                if (c) {
+                    if (!c->cache_loaded) {
+                        ExAcquireResourceExclusiveLite(&c->lock, TRUE);
+
+                        if (!c->cache_loaded) {
+                            Status = load_cache_chunk(Vcb, c, NULL);
+
+                            if (!NT_SUCCESS(Status)) {
+                                ERR("load_cache_chunk returned %08x\n", Status);
+                                ExReleaseResourceLite(&c->lock);
+                                return Status;
+                            }
+                        }
+
+                        ExReleaseResourceLite(&c->lock);
+                    }
+                }
+            }
+
             Status = get_tree_new_address(Vcb, t, Irp, rollback);
             if (!NT_SUCCESS(Status)) {
                 ERR("get_tree_new_address returned %08x\n", Status);
                 return Status;
             }
-            
+
             TRACE("allocated extent %llx\n", t->new_address);
-            
+
             c = get_chunk_from_address(Vcb, t->new_address);
-            
-            if (c) {
-                increase_chunk_usage(c, Vcb->superblock.node_size);
-            } else {
+
+            if (c)
+                c->used += Vcb->superblock.node_size;
+            else {
                 ERR("could not find chunk for address %llx\n", t->new_address);
                 return STATUS_INTERNAL_ERROR;
             }
-            
+
             changed = TRUE;
-            
+
             if (t->header.level > max_level)
                 max_level = t->header.level;
         }
-        
+
         le = le->Flink;
     }
-    
+
     if (!changed)
         return STATUS_SUCCESS;
-    
+
     level = max_level;
     do {
         le = Vcb->trees.Flink;
         while (le != &Vcb->trees) {
             tree* t = CONTAINING_RECORD(le, tree, list_entry);
-            
+
             if (t->write && !t->updated_extents && t->has_address && t->header.level == level) {
                 Status = update_tree_extents(Vcb, t, Irp, rollback);
                 if (!NT_SUCCESS(Status)) {
